package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.ui.TooltipMakerAPI;

import java.awt.*;

public class sfcamaccelerator extends BaseHullMod {

	public static final float TURRET_SPEED_BONUS = 30f;
	public static final float WEAPON_SPEED_BONUS = 20f;
	public static final float TURRET_HEALTH_DECREASE = 25f;
	
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getWeaponTurnRateBonus().modifyPercent(id, TURRET_SPEED_BONUS);
		stats.getBeamWeaponTurnRateBonus().modifyPercent(id, TURRET_SPEED_BONUS);
		stats.getBallisticProjectileSpeedMult().modifyPercent(id, WEAPON_SPEED_BONUS);
		stats.getEnergyProjectileSpeedMult().modifyPercent(id, WEAPON_SPEED_BONUS);
		stats.getWeaponHealthBonus().modifyPercent(id, -TURRET_HEALTH_DECREASE);

	}
	
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) {
			return "" + (int) TURRET_SPEED_BONUS + "%";
		}
		if (index == 1) {
			return "" + (int) WEAPON_SPEED_BONUS + "%";
		}
		if (index == 2) {
			return "" + (int) TURRET_HEALTH_DECREASE + "%";
		}
		return null;
	}

	@Override
	public void addPostDescriptionSection(final TooltipMakerAPI tooltip, final ShipAPI.HullSize hullSize, final ShipAPI ship, final float width, final boolean isForModSpec) {
		final Color flavor = new Color(110,110,110,255);
		float padList = 6f;
		float padSig = 1f;
		tooltip.addPara("%s", padList, flavor, new String[] { "\"Be careful with that! One wrong move and you’ll blow the whole thing sky high. Now hold it still, I need to make sure the calculations are correct.\"" });
		tooltip.addPara("%s", padSig, flavor, new String[] { "         \u2014 Lead Developer Gregory Mannfred" });
	}


}
