package data.hullmods;

import java.awt.Color;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.ui.TooltipMakerAPI;
import com.fs.starfarer.api.util.Misc;

public class sfcantiengine extends BaseHullMod {
	
	private static final float ZERO_FLUX_MULT = 5f;
	private static final float ENGINE_MULT = 50f;
	private static final float SUPPLY_USE_MULT = 1.50f;
	private static final float SENSOR_MULT = 2f;
	
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getZeroFluxMinimumFluxLevel().modifyFlat(id, ZERO_FLUX_MULT * 0.01f); // should set it usable at 5% or lower
		stats.getZeroFluxSpeedBoost().modifyFlat(id, ZERO_FLUX_MULT * 5f); // should increase zero flux bonus to +25 speed
		stats.getEngineHealthBonus().modifyPercent(id, -ENGINE_MULT); // should decrease engine durability
		stats.getSuppliesPerMonth().modifyMult(id, SUPPLY_USE_MULT); // should set supply use to 150% of regular use
		stats.getFuelUseMod().modifyMult(id, SUPPLY_USE_MULT); // should set fuel use to 150% of regular use
		stats.getSensorProfile().modifyMult(id, SENSOR_MULT); // should increase sensor profile
	}
	
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) {
			return "" + Misc.getRoundedValue(ZERO_FLUX_MULT) + "%";
		}
		if (index == 1) {
			return "" + Misc.getRoundedValue(ZERO_FLUX_MULT * 5f);
		}
		if (index == 2) {
			return "" + (int)(ENGINE_MULT) + "%";
		}
		if (index == 3) {
			return "" + (int)((SUPPLY_USE_MULT - 1f) * 100f) + "%";
		}
		if (index == 4) {
			return "" + (int)((SUPPLY_USE_MULT - 1f) * 100f) + "%";
		}
		if (index == 5) {
			return "" + (int)((SENSOR_MULT) * 100f) + "%";
		}
		return null;
	}

	private final Color color = new Color(120,0,57,255);
	@Override
	public void advanceInCombat(ShipAPI ship, float amount) {
			ship.getEngineController().fadeToOtherColor(this, color, null, 1f, 0.4f);
			ship.getEngineController().extendFlame(this, 0.25f, 0.25f, 0.25f);
	}
	@Override
	public void addPostDescriptionSection(final TooltipMakerAPI tooltip, final ShipAPI.HullSize hullSize, final ShipAPI ship, final float width, final boolean isForModSpec) {
		final Color flavor = new Color(110,110,110,255);
		float padList = 6f;
		float padSig = 1f;
		tooltip.addPara("%s", padList, flavor, new String[] { "\"The prototype exploded? And you're saying it's because my calculations are wrong!? Impossible! You must have built it wrong, you imbecile. Now build it again and follow my instructions to the letter, or I’ll have you thrown out of this building!\"" });
		tooltip.addPara("%s", padSig, flavor, new String[] { "         \u2014 Head Researcher, Yunris Kween" });
	}
}
